﻿using System;
using System.Collections.Generic;
using System.Windows.Input;

namespace Polecenie
{
    class Program
    {
        private static void wykonajPolecenie(ICommand polecenie, object parametr = null)
        {
            if (polecenie.CanExecute(parametr)) polecenie.Execute(parametr);
            else Console.WriteLine("Nie można wykonać polecenia");
        }

        static void Main(string[] args)
        {
            try //powinno być wokół każdego przelewu osobno
            {
                Konto konto1 = new Konto(1, 100);
                Konto konto2 = new Konto(2, 150);

                konto1.WyświetlSaldo();
                konto2.WyświetlSaldo();

                //Konto.Przelew(konto1, konto2, 50);
                ICommand polecenieA = new PoleceniePrzelewu(konto1, konto2, 50);
                ICommand polecenieB = new PoleceniePrzelewu(konto2, konto1, 100);

                wykonajPolecenie(polecenieA);

                //List<IPolecenie> polecenia = new List<IPolecenie>();
                //polecenia.Add(polecenieA);
                //polecenia.Add(polecenieB);
                //foreach (IPolecenie polecenie in polecenia) wykonajPolecenie(polecenie);

                konto1.WyświetlSaldo();
                konto2.WyświetlSaldo();

                //Konto.Przelew(konto2, konto1, 100);
                wykonajPolecenie(polecenieB);
                wykonajPolecenie(polecenieA);

                konto1.WyświetlSaldo();
                konto2.WyświetlSaldo();
            }
            catch (Exception exc)
            {
                Console.Error.WriteLine("Błąd: " + exc.Message);
            }
        }
    }
}
